MODULE cordic1;

SFR P3; DP3; S0BG; S0CON;
    S0RIC; S0TIC;

VAR p, x, y: INTEGER;

	PROCEDURE* SinCos(angle: INTEGER; VAR sin, cos: INTEGER);
	CONST scale = 8191;
	VAR i, sint, cost, sinl, cosl: INTEGER;
	BEGIN 
	  VERBATIM
	    jmp		SinCos1
	   ; Tabelle der Arcustangenswerte:
	   SinCosd: DW 9000, 5313, 2807, 1425, 715, 358, 179, 90
		    DW 45, 22, 11, 6, 3, 1, 1, 0
	   SinCos1:
	     mov	R3, #SinCosd
	  END_VERBATIM	  
	  sinl := 0; cosl := (12145 * scale) DIV 10000; angle := angle * 2;
	  FOR i := 0 TO 12 DO
	  VERBATIM
	    mov		R11, 	R9			; sint := sinl
	    ashr	R11, R12			; sint >> i
	    mov		R10, 	R8			; cost := cosl
	    ashr	R10, R12			; cost >> i
	    cmp		R15, 	#0000
	    jmp		SLT, 	SinCos2
	    add		R9, 	R10			; sinl := sinl + cost
	    sub		R8, 	R11			; cosl := cosl - sint	      
	    sub		R15, 	[R3+]			; angle := angle - arctan
	    jmp		SinCos3
	  Sincos2:
	    sub	R9, 	R10				; sinl := sinl - cost
	    add	R8, 	R11				; cosl := cosl + sint
	    add	R15, 	[R3+]			;	 angle := angle + arctan
	  SinCos3:
	  END_VERBATIM
	  END;
	  sin := sinl DIV 2; cos := cosl DIV 2;
	END SinCos;
	
	PROCEDURE* IniASC0;
	  VAR i: INTEGER;
	BEGIN i := DP3; DP3 := i ORB 1024; (* P3.10 = TxD, output *)
	  i := P3; P3 := i ORB 1024; (* P3.10 = TxD = 1 *)
	  S0BG := 15; (* 38400 Baud bei 20 MHz Takt *)
	  S0RIC := 0; S0TIC := 0; (* keine Interrupts hierdurch *)
	  S0CON := $8011; (* 8N1 *)
	END IniASC0;
	
BEGIN DP3 := 255; P3 := 255; IniASC0;
  p := 0; 
    WHILE p < 9100 DO
      SinCos(p, y, x);
      WriteLn(p, " : ", y, " / ", x);
      p := p + 500;
   END;
   p := 0;
  Sleep;
END cordic1..
